]> git.proxmox.com Git - mirror_ubuntu-jammy-kernel.git/blob - scripts/link-vmlinux.sh
kbuild: merge vmlinux_link() between ARCH=um and other architectures
[mirror_ubuntu-jammy-kernel.git] / scripts / link-vmlinux.sh
1 #!/bin/sh
2 # SPDX-License-Identifier: GPL-2.0
3 #
4 # link vmlinux
5 #
6 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7 # $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8 # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9 # $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10 # (not within --whole-archive), and do not require symbol indexes added.
11 #
12 # vmlinux
13 # ^
14 # |
15 # +--< $(KBUILD_VMLINUX_OBJS)
16 # | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17 # |
18 # +--< $(KBUILD_VMLINUX_LIBS)
19 # | +--< lib/lib.a + more
20 # |
21 # +-< ${kallsymso} (see description in KALLSYMS section)
22 #
23 # vmlinux version (uname -v) cannot be updated during normal
24 # descending-into-subdirs phase since we do not yet know if we need to
25 # update vmlinux.
26 # Therefore this step is delayed until just before final link of vmlinux.
27 #
28 # System.map is generated to document addresses of all kernel symbols
29
30 # Error out on error
31 set -e
32
33 LD="$1"
34 KBUILD_LDFLAGS="$2"
35 LDFLAGS_vmlinux="$3"
36
37 # Nice output in kbuild format
38 # Will be supressed by "make -s"
39 info()
40 {
41 printf " %-7s %s\n" "${1}" "${2}"
42 }
43
44 # Generate a linker script to ensure correct ordering of initcalls.
45 gen_initcalls()
46 {
47 info GEN .tmp_initcalls.lds
48
49 ${PYTHON} ${srctree}/scripts/jobserver-exec \
50 ${PERL} ${srctree}/scripts/generate_initcall_order.pl \
51 ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS} \
52 > .tmp_initcalls.lds
53 }
54
55 # If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
56 # .tmp_symversions.lds
57 gen_symversions()
58 {
59 info GEN .tmp_symversions.lds
60 rm -f .tmp_symversions.lds
61
62 for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
63 if [ -f ${o}.symversions ]; then
64 cat ${o}.symversions >> .tmp_symversions.lds
65 fi
66 done
67 }
68
69 # Link of vmlinux.o used for section mismatch analysis
70 # ${1} output file
71 modpost_link()
72 {
73 local objects
74 local lds=""
75
76 objects="--whole-archive \
77 ${KBUILD_VMLINUX_OBJS} \
78 --no-whole-archive \
79 --start-group \
80 ${KBUILD_VMLINUX_LIBS} \
81 --end-group"
82
83 if [ -n "${CONFIG_LTO_CLANG}" ]; then
84 gen_initcalls
85 lds="-T .tmp_initcalls.lds"
86
87 if [ -n "${CONFIG_MODVERSIONS}" ]; then
88 gen_symversions
89 lds="${lds} -T .tmp_symversions.lds"
90 fi
91
92 # This might take a while, so indicate that we're doing
93 # an LTO link
94 info LTO ${1}
95 else
96 info LD ${1}
97 fi
98
99 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
100 }
101
102 objtool_link()
103 {
104 local objtoolcmd;
105 local objtoolopt;
106
107 if [ "${CONFIG_LTO_CLANG} ${CONFIG_STACK_VALIDATION}" = "y y" ]; then
108 # Don't perform vmlinux validation unless explicitly requested,
109 # but run objtool on vmlinux.o now that we have an object file.
110 if [ -n "${CONFIG_UNWINDER_ORC}" ]; then
111 objtoolcmd="orc generate"
112 fi
113
114 objtoolopt="${objtoolopt} --duplicate"
115
116 if [ -n "${CONFIG_FTRACE_MCOUNT_USE_OBJTOOL}" ]; then
117 objtoolopt="${objtoolopt} --mcount"
118 fi
119 fi
120
121 if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
122 objtoolopt="${objtoolopt} --noinstr"
123 fi
124
125 if [ -n "${objtoolopt}" ]; then
126 if [ -z "${objtoolcmd}" ]; then
127 objtoolcmd="check"
128 fi
129 objtoolopt="${objtoolopt} --vmlinux"
130 if [ -z "${CONFIG_FRAME_POINTER}" ]; then
131 objtoolopt="${objtoolopt} --no-fp"
132 fi
133 if [ -n "${CONFIG_GCOV_KERNEL}" ] || [ -n "${CONFIG_LTO_CLANG}" ]; then
134 objtoolopt="${objtoolopt} --no-unreachable"
135 fi
136 if [ -n "${CONFIG_RETPOLINE}" ]; then
137 objtoolopt="${objtoolopt} --retpoline"
138 fi
139 if [ -n "${CONFIG_X86_SMAP}" ]; then
140 objtoolopt="${objtoolopt} --uaccess"
141 fi
142 info OBJTOOL ${1}
143 tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
144 fi
145 }
146
147 # Link of vmlinux
148 # ${1} - output file
149 # ${2}, ${3}, ... - optional extra .o files
150 vmlinux_link()
151 {
152 local output=${1}
153 local objs
154 local libs
155 local ld
156 local ldflags
157 local ldlibs
158
159 info LD ${output}
160
161 # skip output file argument
162 shift
163
164 if [ -n "${CONFIG_LTO_CLANG}" ]; then
165 # Use vmlinux.o instead of performing the slow LTO link again.
166 objs=vmlinux.o
167 libs=
168 else
169 objs="${KBUILD_VMLINUX_OBJS}"
170 libs="${KBUILD_VMLINUX_LIBS}"
171 fi
172
173 if [ "${SRCARCH}" = "um" ]; then
174 wl=-Wl,
175 ld="${CC}"
176 ldflags="${CFLAGS_vmlinux}"
177 ldlibs="-lutil -lrt -lpthread"
178 else
179 wl=
180 ld="${LD}"
181 ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
182 ldlibs=
183 fi
184
185 ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
186
187 # The kallsyms linking does not need debug symbols included.
188 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
189 ldflags="${ldflags} ${wl}--strip-debug"
190 fi
191
192 if [ -n "${CONFIG_VMLINUX_MAP}" ]; then
193 ldflags="${ldflags} ${wl}-Map=${output}.map"
194 fi
195
196 ${ld} ${ldflags} -o ${output} \
197 ${wl}--whole-archive ${objs} ${wl}--no-whole-archive \
198 ${wl}--start-group ${libs} ${wl}--end-group \
199 $@ ${ldlibs}
200 }
201
202 # generate .BTF typeinfo from DWARF debuginfo
203 # ${1} - vmlinux image
204 # ${2} - file to dump raw BTF data into
205 gen_btf()
206 {
207 local pahole_ver
208 local extra_paholeopt=
209
210 if ! [ -x "$(command -v ${PAHOLE})" ]; then
211 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
212 return 1
213 fi
214
215 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
216 if [ "${pahole_ver}" -lt "116" ]; then
217 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
218 return 1
219 fi
220
221 vmlinux_link ${1}
222
223 if [ "${pahole_ver}" -ge "118" ] && [ "${pahole_ver}" -le "121" ]; then
224 # pahole 1.18 through 1.21 can't handle zero-sized per-CPU vars
225 extra_paholeopt="${extra_paholeopt} --skip_encoding_btf_vars"
226 fi
227 if [ "${pahole_ver}" -ge "121" ]; then
228 extra_paholeopt="${extra_paholeopt} --btf_gen_floats"
229 fi
230
231 info "BTF" ${2}
232 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${extra_paholeopt} ${1}
233
234 # Create ${2} which contains just .BTF section but no symbols. Add
235 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
236 # deletes all symbols including __start_BTF and __stop_BTF, which will
237 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
238 # objcopy warnings: "empty loadable segment detected at ..."
239 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
240 --strip-all ${1} ${2} 2>/dev/null
241 # Change e_type to ET_REL so that it can be used to link final vmlinux.
242 # Unlike GNU ld, lld does not allow an ET_EXEC input.
243 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
244 }
245
246 # Create ${2} .S file with all symbols from the ${1} object file
247 kallsyms()
248 {
249 local kallsymopt;
250
251 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
252 kallsymopt="${kallsymopt} --all-symbols"
253 fi
254
255 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
256 kallsymopt="${kallsymopt} --absolute-percpu"
257 fi
258
259 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
260 kallsymopt="${kallsymopt} --base-relative"
261 fi
262
263 info KSYMS ${2}
264 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
265 }
266
267 # Perform one step in kallsyms generation, including temporary linking of
268 # vmlinux.
269 kallsyms_step()
270 {
271 kallsymso_prev=${kallsymso}
272 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
273 kallsymso=${kallsyms_vmlinux}.o
274 kallsyms_S=${kallsyms_vmlinux}.S
275
276 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
277 kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
278
279 info AS ${kallsyms_S}
280 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
281 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
282 -c -o ${kallsymso} ${kallsyms_S}
283 }
284
285 # Create map file with all symbols from ${1}
286 # See mksymap for additional details
287 mksysmap()
288 {
289 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
290 }
291
292 sorttable()
293 {
294 ${objtree}/scripts/sorttable ${1}
295 }
296
297 # Delete output files in case of error
298 cleanup()
299 {
300 rm -f .btf.*
301 rm -f .tmp_System.map
302 rm -f .tmp_initcalls.lds
303 rm -f .tmp_symversions.lds
304 rm -f .tmp_vmlinux*
305 rm -f System.map
306 rm -f vmlinux
307 rm -f vmlinux.map
308 rm -f vmlinux.o
309 rm -f .vmlinux.d
310 }
311
312 # Use "make V=1" to debug this script
313 case "${KBUILD_VERBOSE}" in
314 *1*)
315 set -x
316 ;;
317 esac
318
319 if [ "$1" = "clean" ]; then
320 cleanup
321 exit 0
322 fi
323
324 # We need access to CONFIG_ symbols
325 . include/config/auto.conf
326
327 # Update version
328 info GEN .version
329 if [ -r .version ]; then
330 VERSION=$(expr 0$(cat .version) + 1)
331 echo $VERSION > .version
332 else
333 rm -f .version
334 echo 1 > .version
335 fi;
336
337 # final build of init/
338 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
339
340 #link vmlinux.o
341 modpost_link vmlinux.o
342 objtool_link vmlinux.o
343
344 # modpost vmlinux.o to check for section mismatches
345 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
346
347 info MODINFO modules.builtin.modinfo
348 ${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
349 info GEN modules.builtin
350 # The second line aids cases where multiple modules share the same object.
351 tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
352 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
353
354 btf_vmlinux_bin_o=""
355 if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
356 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
357 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
358 echo >&2 "Failed to generate BTF for vmlinux"
359 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
360 exit 1
361 fi
362 fi
363
364 kallsymso=""
365 kallsymso_prev=""
366 kallsyms_vmlinux=""
367 if [ -n "${CONFIG_KALLSYMS}" ]; then
368
369 # kallsyms support
370 # Generate section listing all symbols and add it into vmlinux
371 # It's a three step process:
372 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
373 # but __kallsyms is empty.
374 # Running kallsyms on that gives us .tmp_kallsyms1.o with
375 # the right size
376 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
377 # the right size, but due to the added section, some
378 # addresses have shifted.
379 # From here, we generate a correct .tmp_kallsyms2.o
380 # 3) That link may have expanded the kernel image enough that
381 # more linker branch stubs / trampolines had to be added, which
382 # introduces new names, which further expands kallsyms. Do another
383 # pass if that is the case. In theory it's possible this results
384 # in even more stubs, but unlikely.
385 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
386 # other bugs.
387 # 4) The correct ${kallsymso} is linked into the final vmlinux.
388 #
389 # a) Verify that the System.map from vmlinux matches the map from
390 # ${kallsymso}.
391
392 kallsyms_step 1
393 kallsyms_step 2
394
395 # step 3
396 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
397 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
398
399 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
400 kallsyms_step 3
401 fi
402 fi
403
404 vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
405
406 # fill in BTF IDs
407 if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then
408 info BTFIDS vmlinux
409 ${RESOLVE_BTFIDS} vmlinux
410 fi
411
412 if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
413 info SORTTAB vmlinux
414 if ! sorttable vmlinux; then
415 echo >&2 Failed to sort kernel tables
416 exit 1
417 fi
418 fi
419
420 info SYSMAP System.map
421 mksysmap vmlinux System.map
422
423 # step a (see comment above)
424 if [ -n "${CONFIG_KALLSYMS}" ]; then
425 mksysmap ${kallsyms_vmlinux} .tmp_System.map
426
427 if ! cmp -s System.map .tmp_System.map; then
428 echo >&2 Inconsistent kallsyms data
429 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
430 exit 1
431 fi
432 fi
433
434 # For fixdep
435 echo "vmlinux: $0" > .vmlinux.d